#include <stdio.h>
#include <HRPC/basicRpc.h>
#include "RawTCPTest.h"		/* Don't use _defs.h, since will cause name
				   clashes between the 2 protocols */
#include "RawUDPTest.h"

main(argc, argv)
int argc;
char **argv;
{
	HRPCBinding *bptr = (HRPCBinding *) NULL;
	/* RawTCP and RawUDP test msgs are the same */
	RawTCPTest_TestMsg IncomingMsg, OutgoingMsg;
        char HostName[100];
	char WhichPcl[20];

	fputs("TCP/UDP? ", stdout);
	scanf("%s", WhichPcl);
	fputs("HostName? ", stdout);
	scanf("%s", HostName);

	OutgoingMsg.IntPart = 1234;
	OutgoingMsg.LongPart = 234567;
	OutgoingMsg.BoolPart = 0;

	if ( (*WhichPcl == 't') || (*WhichPcl == 'T') ) {
		OutgoingMsg.StringPart = "TCP HRPC client string";
		RawTCPTest_Import(HostName, &bptr);
		RawTCPTest_TestProc(bptr, &OutgoingMsg, &IncomingMsg);
	} else {
		OutgoingMsg.StringPart = "UDP HRPC client string";
		RawUDPTest_Import(HostName, &bptr);
		RawUDPTest_TestProc(bptr, &OutgoingMsg, &IncomingMsg);
	}

	printf("HRPC client: received msg: IntPart=%d, LongPart=%ld, BoolPart=%ld, StringPart='%s'\n",
		IncomingMsg.IntPart, IncomingMsg.LongPart, 
		IncomingMsg.BoolPart, IncomingMsg.StringPart);
}
